﻿using System;
using System.Windows.Forms;

namespace MapTileSet
{
    public partial class TfmMain : Form
    {
        private MapReader mapFile;
        OpenFileDialog OFD = new OpenFileDialog();

        byte
            Objects1 = 0,
            Objects2 = 0;

        //157 = obj37

        public TfmMain()
        {
            InitializeComponent();
        }

        private void btnSelectMap_Click(object sender, EventArgs e)
        {
            OFD.ShowDialog();

            if (OFD.FileName == null)
                return;
            else
            {
                lbMap.Text = string.Format("Map {0}", OFD.FileName);
                try
                {
                    mapFile = new MapReader(OFD.FileName);

                    Objects1 = (byte)mapFile.MapCells[0, 0].FrontIndex;
                    for (int x = 0; x < mapFile.Width; x++)
                    {
                        for (int y = 0; y < mapFile.Height; y++)
                        {
                            if ((byte)mapFile.MapCells[x, y].FrontIndex == Objects1)
                                continue;
                            else
                            {
                                Objects2 = (byte)mapFile.MapCells[x, y].FrontIndex;
                                break;
                            }
                        }
                    }

                    lbObjects.Text = string.Format("Objects {0}", Objects1 - 119);
                    lbObjects2.Text = string.Format("Objects {0}", Objects2 - 119);
                }
                catch (Exception)
                {
                }
            }
        }

        private void btnProcess_Click(object sender, EventArgs e)
        {
            for (int x = 0; x < mapFile.Width; x++)
            {
                for (int y = 0; y < mapFile.Height; y++)
                {
                    if (mapFile.MapCells[x, y].FrontIndex == Objects1)
                    {
                        mapFile.MapCells[x, y].FrontIndex = Convert.ToByte(nudObjects.Value + 119);
                        mapFile.MapCells[x, y].FrontImage += Convert.ToInt32(nudFirstIndex.Value);
                    }
                    else
                    {
                        mapFile.MapCells[x, y].FrontIndex = Convert.ToByte(nudObjects2.Value + 119);
                        mapFile.MapCells[x, y].FrontImage += Convert.ToInt32(nudFirstIndex2.Value);
                    }
                }
            }
            mapFile.Save(OFD.FileName);
            MessageBox.Show("done");
        }
    }
}